
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "mpsl.y"

/*

    MPSL - Minimum Profit Scripting Language
    Copyright (C) 2003/2012 Angel Ortega <angel@triptico.com>

    mpsl.y - Minimum Profit Scripting Language YACC parser

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    http://triptico.com

*/

#include <stdio.h>
#include <string.h>
#include <wchar.h>
#include "mpdm.h"
#include "mpsl.h"

/** data **/

/* the bytecode being generated */
static mpdm_t mpsl_bytecode = NULL;

/* pointer to source code being compiled */
extern wchar_t *mpsl_next_char;

/* pointer to file being compiled */
extern FILE *mpsl_file;

/* line number */
extern int mpsl_line;

/* compiled filename (for errors) */
static char *mpsl_filename = NULL;

/* cached value MPSL.OPCODE */
extern mpdm_t mpsl_opcodes;

/* cached value MPSL.LC */
extern mpdm_t mpsl_lc;


/** code **/

int yylex(void);
void yyerror(char *s);

#define INS0(o)             mpsl_mkins(o, 0, NULL, NULL, NULL, NULL)
#define INS1(o,a1)          mpsl_mkins(o, 1, a1, NULL, NULL, NULL)
#define INS2(o,a1,a2)       mpsl_mkins(o, 2, a1, a2, NULL, NULL)
#define INS3(o,a1,a2,a3)    mpsl_mkins(o, 3, a1, a2, a3, NULL)
#define INS4(o,a1,a2,a3,a4) mpsl_mkins(o, 4, a1, a2, a3, a4)

static mpdm_t mpsl_x(mpdm_t a1, mpdm_t a2, int sf)
/* creates an executable value with the MPSL executor as the first
   argument and a compiled stream as the second */
{
    return MPDM_X2(mpsl_exec_p,
                   mpsl_mkins(sf ? L"SUBFRAME" : L"BLKFRAME",
                              a2 == NULL ? 1 : 2, a1, a2, NULL, NULL));
}


static void compiler_warning(char *str)
{
    fprintf(stderr, "WARNING: %s.\n", str);
}




/* Line 189 of yacc.c  */
#line 159 "y.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     NULLV = 258,
     INTEGER = 259,
     REAL = 260,
     STRING = 261,
     SYMBOL = 262,
     LITERAL = 263,
     WHILE = 264,
     FOR = 265,
     IF = 266,
     SUB = 267,
     FOREACH = 268,
     LOCAL = 269,
     GLOBAL = 270,
     BREAK = 271,
     RETURN = 272,
     IFI = 273,
     ELSE = 274,
     BOOLOR = 275,
     BOOLAND = 276,
     ISHL = 277,
     ISHR = 278,
     IBITXOR = 279,
     IBITOR = 280,
     IBITAND = 281,
     IMOD = 282,
     IDIV = 283,
     IMUL = 284,
     ISUB = 285,
     IADD = 286,
     DEC = 287,
     INC = 288,
     RANGE = 289,
     ARROW = 290,
     NUMLE = 291,
     NUMGE = 292,
     NUMNE = 293,
     STRNE = 294,
     NUMEQ = 295,
     STREQ = 296,
     STRCAT = 297,
     AMPERSAND = 298,
     BITXOR = 299,
     BITOR = 300,
     SHR = 301,
     SHL = 302,
     POW = 303,
     MOD = 304,
     INVCALL = 305,
     UMINUS = 306
   };
#endif
/* Tokens.  */
#define NULLV 258
#define INTEGER 259
#define REAL 260
#define STRING 261
#define SYMBOL 262
#define LITERAL 263
#define WHILE 264
#define FOR 265
#define IF 266
#define SUB 267
#define FOREACH 268
#define LOCAL 269
#define GLOBAL 270
#define BREAK 271
#define RETURN 272
#define IFI 273
#define ELSE 274
#define BOOLOR 275
#define BOOLAND 276
#define ISHL 277
#define ISHR 278
#define IBITXOR 279
#define IBITOR 280
#define IBITAND 281
#define IMOD 282
#define IDIV 283
#define IMUL 284
#define ISUB 285
#define IADD 286
#define DEC 287
#define INC 288
#define RANGE 289
#define ARROW 290
#define NUMLE 291
#define NUMGE 292
#define NUMNE 293
#define STRNE 294
#define NUMEQ 295
#define STREQ 296
#define STRCAT 297
#define AMPERSAND 298
#define BITXOR 299
#define BITOR 300
#define SHR 301
#define SHL 302
#define POW 303
#define MOD 304
#define INVCALL 305
#define UMINUS 306




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 86 "mpsl.y"

	mpdm_t v;	/* a simple value */
	mpdm_t ins;	/* an 'instruction': [ opcode, args ] */



/* Line 214 of yacc.c  */
#line 304 "y.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 316 "y.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1799

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  70
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  10
/* YYNRULES -- Number of rules.  */
#define YYNRULES  96
/* YYNRULES -- Number of states.  */
#define YYNSTATES  235

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   306

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    34,     2,     2,     2,     2,     2,     2,
      61,    62,    54,    52,    65,    53,    67,    55,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    35,    60,
      37,    66,    36,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    68,     2,    69,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    63,     2,    64,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    56,    57,    58,    59
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     8,     9,    11,    14,    20,    30,
      37,    43,    51,    57,    65,    74,    82,    91,    95,    99,
     105,   109,   115,   118,   122,   125,   127,   130,   132,   136,
     138,   142,   146,   150,   156,   162,   164,   168,   172,   177,
     179,   181,   183,   185,   187,   190,   194,   198,   202,   206,
     210,   214,   218,   222,   226,   230,   234,   237,   240,   243,
     246,   250,   254,   258,   262,   266,   270,   274,   278,   282,
     286,   289,   293,   297,   301,   305,   309,   313,   317,   321,
     325,   329,   333,   338,   346,   350,   353,   357,   363,   366,
     370,   374,   379,   385,   392,   397,   403
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      71,     0,    -1,    72,    -1,    72,    74,    -1,    -1,    60,
      -1,    79,    60,    -1,     9,    61,    79,    62,    73,    -1,
      10,    61,    79,    60,    79,    60,    79,    62,    73,    -1,
      10,    61,    60,    60,    62,    73,    -1,    11,    61,    79,
      62,    73,    -1,    11,    61,    79,    62,    73,    19,    73,
      -1,    12,    78,    63,    74,    64,    -1,    12,    78,    61,
      62,    63,    74,    64,    -1,    12,    78,    61,    76,    62,
      63,    74,    64,    -1,    13,    61,    78,    65,    79,    62,
      73,    -1,    13,    61,    14,    78,    65,    79,    62,    73,
      -1,    63,    74,    64,    -1,    14,    76,    60,    -1,    14,
       7,    66,    79,    60,    -1,    15,    76,    60,    -1,    15,
       7,    66,    79,    60,    -1,    16,    60,    -1,    17,    79,
      60,    -1,    17,    60,    -1,    73,    -1,    74,    73,    -1,
      79,    -1,    75,    65,    79,    -1,     7,    -1,    76,    65,
       7,    -1,    79,    39,    79,    -1,     7,    35,    79,    -1,
      77,    65,    79,    39,    79,    -1,    77,    65,     7,    35,
      79,    -1,     7,    -1,    78,    67,     4,    -1,    78,    67,
       7,    -1,    78,    68,    79,    69,    -1,     4,    -1,     6,
      -1,     5,    -1,    78,    -1,     3,    -1,    53,    79,    -1,
      79,    52,    79,    -1,    79,    53,    79,    -1,    79,    54,
      79,    -1,    79,    55,    79,    -1,    79,    57,    79,    -1,
      79,    56,    79,    -1,    79,    47,    79,    -1,    79,    49,
      79,    -1,    79,    48,    79,    -1,    79,    51,    79,    -1,
      79,    50,    79,    -1,    33,    78,    -1,    32,    78,    -1,
      78,    33,    -1,    78,    32,    -1,    78,    31,    79,    -1,
      78,    30,    79,    -1,    78,    29,    79,    -1,    78,    28,
      79,    -1,    78,    27,    79,    -1,    78,    26,    79,    -1,
      78,    25,    79,    -1,    78,    24,    79,    -1,    78,    22,
      79,    -1,    78,    23,    79,    -1,    34,    79,    -1,    79,
      37,    79,    -1,    79,    36,    79,    -1,    79,    40,    79,
      -1,    79,    41,    79,    -1,    79,    44,    79,    -1,    79,
      42,    79,    -1,    79,    46,    79,    -1,    79,    45,    79,
      -1,    79,    43,    79,    -1,    79,    21,    79,    -1,    79,
      20,    79,    -1,    12,    63,    74,    64,    -1,    12,    61,
      76,    62,    63,    74,    64,    -1,    61,    79,    62,    -1,
      68,    69,    -1,    68,    75,    69,    -1,    68,    79,    38,
      79,    69,    -1,    63,    64,    -1,    63,    77,    64,    -1,
      78,    61,    62,    -1,    78,    61,    75,    62,    -1,    79,
      58,    78,    61,    62,    -1,    79,    58,    78,    61,    75,
      62,    -1,    47,    78,    61,    62,    -1,    47,    78,    61,
      75,    62,    -1,    78,    66,    79,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   113,   113,   117,   120,   124,   128,   133,   138,   143,
     148,   153,   159,   168,   178,   187,   199,   211,   217,   221,
     232,   236,   247,   251,   255,   262,   263,   270,   273,   281,
     285,   293,   296,   299,   305,   314,   318,   323,   328,   335,
     339,   343,   347,   351,   356,   362,   363,   364,   365,   366,
     367,   370,   371,   372,   373,   374,   377,   384,   393,   403,
     415,   421,   427,   433,   439,   445,   451,   457,   463,   469,
     476,   480,   484,   488,   492,   496,   500,   506,   510,   514,
     520,   524,   529,   534,   540,   545,   549,   553,   559,   563,
     568,   572,   576,   580,   584,   588,   592
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "NULLV", "INTEGER", "REAL", "STRING",
  "SYMBOL", "LITERAL", "WHILE", "FOR", "IF", "SUB", "FOREACH", "LOCAL",
  "GLOBAL", "BREAK", "RETURN", "IFI", "ELSE", "BOOLOR", "BOOLAND", "ISHL",
  "ISHR", "IBITXOR", "IBITOR", "IBITAND", "IMOD", "IDIV", "IMUL", "ISUB",
  "IADD", "DEC", "INC", "'!'", "':'", "'>'", "'<'", "RANGE", "ARROW",
  "NUMLE", "NUMGE", "NUMNE", "STRNE", "NUMEQ", "STREQ", "STRCAT",
  "AMPERSAND", "BITXOR", "BITOR", "SHR", "SHL", "'+'", "'-'", "'*'", "'/'",
  "POW", "MOD", "INVCALL", "UMINUS", "';'", "'('", "')'", "'{'", "'}'",
  "','", "'='", "'.'", "'['", "']'", "$accept", "program", "function",
  "stmt", "stmt_list", "list", "sym_list", "hash", "compsym", "expr", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,    33,    58,    62,    60,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,    43,    45,    42,    47,   303,   304,   305,   306,
      59,    40,    41,   123,   125,    44,    61,    46,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    70,    71,    72,    72,    73,    73,    73,    73,    73,
      73,    73,    73,    73,    73,    73,    73,    73,    73,    73,
      73,    73,    73,    73,    73,    74,    74,    75,    75,    76,
      76,    77,    77,    77,    77,    78,    78,    78,    78,    79,
      79,    79,    79,    79,    79,    79,    79,    79,    79,    79,
      79,    79,    79,    79,    79,    79,    79,    79,    79,    79,
      79,    79,    79,    79,    79,    79,    79,    79,    79,    79,
      79,    79,    79,    79,    79,    79,    79,    79,    79,    79,
      79,    79,    79,    79,    79,    79,    79,    79,    79,    79,
      79,    79,    79,    79,    79,    79,    79
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     0,     1,     2,     5,     9,     6,
       5,     7,     5,     7,     8,     7,     8,     3,     3,     5,
       3,     5,     2,     3,     2,     1,     2,     1,     3,     1,
       3,     3,     3,     5,     5,     1,     3,     3,     4,     1,
       1,     1,     1,     1,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     2,     2,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     4,     7,     3,     2,     3,     5,     2,     3,
       3,     4,     5,     6,     4,     5,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       4,     0,     2,     1,    43,    39,    41,    40,    35,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     5,     0,     0,     0,    25,     3,    42,
       0,     0,     0,     0,     0,     0,     0,     0,    29,     0,
      29,     0,    22,     0,    24,     0,     0,    57,    56,    70,
       0,    44,     0,    35,    88,     0,     0,     0,    85,     0,
      27,    26,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    59,    58,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     6,     0,     0,     0,     0,    29,     0,     0,     0,
       0,     0,     0,     0,    18,     0,     0,    20,     0,    23,
       0,    84,     0,    17,    89,     0,     0,     0,    86,     0,
      68,    69,    67,    66,    65,    64,    63,    62,    61,    60,
      90,     0,    27,    96,    36,    37,     0,    81,    80,    72,
      71,    73,    74,    76,    79,    75,    78,    77,    51,    53,
      52,    55,    54,    45,    46,    47,    48,    50,    49,     0,
       0,     0,     0,     0,     0,    82,     0,     0,     0,     0,
       0,     0,    30,     0,    94,     0,    32,    35,     0,    31,
      28,     0,    91,    38,     0,     7,     0,     0,    10,     0,
       0,     0,    12,     0,     0,    19,    21,    95,     0,     0,
      87,    92,     0,     9,     0,     0,     0,     0,     0,     0,
       0,    34,    33,    93,     0,    11,    83,    13,     0,     0,
      15,     0,    14,    16,     8
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,     1,     2,    27,    28,    59,    39,    56,    29,    30
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -74
static const yytype_int16 yypact[] =
{
     -74,     8,   689,   -74,   -74,   -74,   -74,   -74,   -74,   -44,
     -21,   -19,    -5,    -9,    50,    56,     5,   706,    99,    99,
     914,    99,   914,   -74,   914,   227,   216,   -74,   689,  1082,
    1355,   914,   758,   914,   111,   689,   -57,     6,    62,   -22,
      73,   -10,   -74,   -38,   -74,   775,  1396,     9,     9,  1741,
     -52,   -74,  1080,    88,   -74,   293,    40,  1314,   -74,   -62,
    1601,   -74,   914,   914,   914,   914,   914,   914,   914,   914,
     914,   914,   -74,   -74,   828,   914,    37,   914,   914,   914,
     914,   914,   914,   914,   914,   914,   914,   914,   914,   914,
     914,   914,   914,   914,   914,   914,   914,   914,   914,   914,
      99,   -74,  1119,    76,  1437,  1158,   -74,   -31,   359,    -2,
     689,    99,   -14,   914,   -74,   133,   914,   -74,  1640,   -74,
     845,   -74,   914,   -74,   -74,   966,   914,   914,   -74,   914,
    1741,  1741,  1741,  1741,  1741,  1741,  1741,  1741,  1741,  1741,
     -74,    54,  1718,  1718,   -74,   -74,   995,  1741,  1741,   104,
     104,   104,   104,   104,   104,   104,   104,   104,   263,   278,
     278,    57,    57,   109,   109,    83,    83,    83,    83,   -49,
     689,    81,   914,   689,    84,   -74,    85,    60,   425,    -6,
     914,  1478,   -74,  1519,   -74,    70,  1718,   114,  1679,  1718,
    1718,  1034,   -74,   -74,   897,   -74,   689,  1560,   125,   689,
     689,   106,   -74,   914,  1197,   -74,   -74,   -74,   914,   914,
     -74,   -74,    72,   -74,   914,   689,   491,   557,   689,  1236,
     689,  1718,  1718,   -74,  1275,   -74,   -74,   -74,   623,   689,
     -74,   689,   -74,   -74,   -74
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -74,   -74,   -74,   -28,    -3,   -73,    -1,   -74,    27,     4
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint8 yytable[] =
{
      61,   141,     8,   127,   109,   106,   110,   128,     3,   120,
      76,    77,   194,     8,    41,    76,    77,    31,    76,    77,
     111,    46,    55,    34,    49,    35,    51,    61,    52,    57,
      60,   174,   108,   107,   115,   102,   104,   105,   114,    36,
      32,   144,    33,   115,   145,    47,    48,   185,    50,   118,
     117,   180,    37,    76,    77,   115,    34,    38,    35,   203,
     176,    76,    77,    40,   112,    42,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,    76,    77,   142,   143,
      61,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   124,   125,     8,   178,   177,    94,
      95,    96,    97,    98,    99,   100,   192,   181,   106,   127,
     183,   212,   201,   122,   142,   115,   186,   169,   113,   188,
     189,   190,   207,   191,   223,   127,   171,   127,   179,   116,
     182,   100,   195,   196,   215,   198,     0,   199,   200,   208,
      61,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,    96,    97,    98,    99,   100,   213,   218,
       0,     0,     0,     0,     0,     0,   197,     0,     0,     0,
       0,     0,     0,     0,   204,     0,     0,   225,    61,    61,
       0,     0,   230,     0,     0,     0,   216,   217,   142,     0,
      61,   233,     0,   234,     0,     0,     0,   219,     0,     0,
       0,     0,   221,   222,     0,   228,     0,     0,   224,     4,
       5,     6,     7,     8,     0,     0,     0,     0,    43,     0,
       4,     5,     6,     7,    53,     0,     9,    10,    11,    12,
      13,    14,    15,    16,    17,     0,     0,     0,    18,    19,
      20,     0,     0,     0,     0,     0,     0,     0,     0,    18,
      19,    20,     0,    21,     0,     0,     0,     0,     0,    22,
       0,     0,     0,     0,    21,     0,     0,    24,     0,    45,
      22,     0,     0,     0,    26,    58,     0,    23,    24,     0,
      25,    54,     0,     0,     0,    26,     4,     5,     6,     7,
       8,     0,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,     0,     0,     0,    18,    19,    20,    92,    93,
      94,    95,    96,    97,    98,    99,   100,     0,     0,     0,
      21,     0,     0,     0,     0,     0,    22,     0,     0,     0,
       0,     0,     0,    23,    24,     0,    25,   123,     0,     0,
       0,    26,     4,     5,     6,     7,     8,     0,     9,    10,
      11,    12,    13,    14,    15,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    18,    19,    20,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    21,     0,     0,     0,
       0,     0,    22,     0,     0,     0,     0,     0,     0,    23,
      24,     0,    25,   175,     0,     0,     0,    26,     4,     5,
       6,     7,     8,     0,     9,    10,    11,    12,    13,    14,
      15,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    18,    19,    20,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    21,     0,     0,     0,     0,     0,    22,     0,
       0,     0,     0,     0,     0,    23,    24,     0,    25,   202,
       0,     0,     0,    26,     4,     5,     6,     7,     8,     0,
       9,    10,    11,    12,    13,    14,    15,    16,    17,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    18,    19,    20,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    21,     0,
       0,     0,     0,     0,    22,     0,     0,     0,     0,     0,
       0,    23,    24,     0,    25,   226,     0,     0,     0,    26,
       4,     5,     6,     7,     8,     0,     9,    10,    11,    12,
      13,    14,    15,    16,    17,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    18,
      19,    20,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    21,     0,     0,     0,     0,     0,
      22,     0,     0,     0,     0,     0,     0,    23,    24,     0,
      25,   227,     0,     0,     0,    26,     4,     5,     6,     7,
       8,     0,     9,    10,    11,    12,    13,    14,    15,    16,
      17,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    18,    19,    20,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      21,     0,     0,     0,     0,     0,    22,     0,     0,     0,
       0,     0,     0,    23,    24,     0,    25,   232,     0,     0,
       0,    26,     4,     5,     6,     7,     8,     0,     9,    10,
      11,    12,    13,    14,    15,    16,    17,     0,     0,     4,
       5,     6,     7,     8,     0,     0,     0,     0,    43,     0,
       0,    18,    19,    20,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    21,     0,    18,    19,
      20,     0,    22,     0,     0,     0,     0,     0,     0,    23,
      24,     0,    25,    21,     0,     0,     0,    26,     0,    22,
       0,     4,     5,     6,     7,     8,    44,    24,     0,    45,
      43,     0,     0,     0,    26,     0,     0,     0,     4,     5,
       6,     7,    53,     0,     0,     0,     0,    43,     0,     0,
      18,    19,    20,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    21,     0,    18,    19,    20,
       0,    22,     0,     0,     0,     0,     0,     0,   103,    24,
       0,    45,    21,     0,     0,     0,    26,     0,    22,     0,
       0,     4,     5,     6,     7,     8,    24,     0,    45,    54,
      43,     0,     0,    26,     0,     0,     0,     0,     4,     5,
       6,     7,     8,     0,     0,     0,     0,    43,     0,     0,
      18,    19,    20,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    21,     0,    18,    19,    20,
       0,    22,     0,     0,     0,     0,     0,     0,     0,    24,
     140,    45,    21,     0,     0,     0,    26,     0,    22,     0,
       4,     5,     6,     7,     8,     0,    24,   184,    45,    43,
       0,     0,     0,    26,     0,     0,     0,     4,     5,     6,
       7,     8,     0,     0,     0,     0,    43,     0,     0,    18,
      19,    20,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    21,     0,    18,    19,    20,     0,
      22,     0,     0,     0,     0,     0,     0,     0,    24,   211,
      45,    21,     0,     0,     0,    26,     0,    22,     0,     4,
       5,     6,     7,   187,     0,    24,     0,    45,    43,     0,
       0,     0,    26,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    18,    19,
      20,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    21,     0,    78,    79,     0,     0,    22,
       0,     0,     0,     0,     0,     0,     0,    24,     0,    45,
       0,    80,    81,     0,    26,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,    78,    79,     0,     0,     0,     0,
       0,     0,     0,     0,   193,     0,     0,     0,     0,     0,
      80,    81,     0,     0,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,     0,     0,     0,     0,     0,     0,     0,
      78,    79,     0,   210,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    80,    81,     0,     0,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,    78,
      79,     0,   121,    74,     0,     0,     0,     0,    75,    76,
      77,     0,     0,     0,     0,    80,    81,     0,     0,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,    78,    79,
       0,   170,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    80,    81,     0,     0,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,    78,    79,     0,
     173,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    80,    81,     0,     0,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,    78,    79,     0,   220,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    80,    81,     0,     0,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,    78,    79,     0,   229,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    80,    81,     0,     0,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,    78,    79,     0,   231,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      80,    81,     0,   126,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,     0,   101,    78,    79,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    80,    81,     0,     0,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,     0,   101,    78,    79,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    80,    81,     0,     0,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,     0,   119,    78,    79,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    80,    81,     0,     0,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,     0,   172,    78,    79,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    80,    81,     0,     0,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,     0,   205,    78,
      79,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    80,    81,     0,     0,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,     0,   206,
      78,    79,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    80,    81,     0,     0,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,     0,
     214,    78,    79,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    80,    81,   129,
       0,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
      78,    79,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    80,    81,     0,   126,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,    78,
      79,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    80,    81,     0,   209,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,    78,    79,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    80,    81,     0,     0,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,    80,    81,     0,
       0,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100
};

static const yytype_int16 yycheck[] =
{
      28,    74,     7,    65,    61,     7,    63,    69,     0,    61,
      67,    68,    61,     7,    15,    67,    68,    61,    67,    68,
      14,    17,    25,    61,    20,    63,    22,    55,    24,    25,
      26,    62,    35,    34,    65,    31,    32,    33,    60,    12,
      61,     4,    61,    65,     7,    18,    19,   120,    21,    45,
      60,    65,    61,    67,    68,    65,    61,     7,    63,    65,
      62,    67,    68,     7,    37,    60,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    67,    68,    74,    75,
     108,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,    64,    65,     7,   110,   109,    52,
      53,    54,    55,    56,    57,    58,    62,   113,     7,    65,
     116,   194,    62,    35,   120,    65,   122,   100,    66,   125,
     126,   127,    62,   129,    62,    65,    60,    65,   111,    66,
       7,    58,   170,    62,    19,   173,    -1,    63,    63,    35,
     178,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    54,    55,    56,    57,    58,   196,    63,
      -1,    -1,    -1,    -1,    -1,    -1,   172,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   180,    -1,    -1,   215,   216,   217,
      -1,    -1,   220,    -1,    -1,    -1,   199,   200,   194,    -1,
     228,   229,    -1,   231,    -1,    -1,    -1,   203,    -1,    -1,
      -1,    -1,   208,   209,    -1,   218,    -1,    -1,   214,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    -1,
       3,     4,     5,     6,     7,    -1,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    -1,    -1,    -1,    32,    33,
      34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,
      33,    34,    -1,    47,    -1,    -1,    -1,    -1,    -1,    53,
      -1,    -1,    -1,    -1,    47,    -1,    -1,    61,    -1,    63,
      53,    -1,    -1,    -1,    68,    69,    -1,    60,    61,    -1,
      63,    64,    -1,    -1,    -1,    68,     3,     4,     5,     6,
       7,    -1,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    -1,    -1,    -1,    32,    33,    34,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    -1,    -1,    -1,
      47,    -1,    -1,    -1,    -1,    -1,    53,    -1,    -1,    -1,
      -1,    -1,    -1,    60,    61,    -1,    63,    64,    -1,    -1,
      -1,    68,     3,     4,     5,     6,     7,    -1,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    32,    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    47,    -1,    -1,    -1,
      -1,    -1,    53,    -1,    -1,    -1,    -1,    -1,    -1,    60,
      61,    -1,    63,    64,    -1,    -1,    -1,    68,     3,     4,
       5,     6,     7,    -1,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,    33,    34,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    47,    -1,    -1,    -1,    -1,    -1,    53,    -1,
      -1,    -1,    -1,    -1,    -1,    60,    61,    -1,    63,    64,
      -1,    -1,    -1,    68,     3,     4,     5,     6,     7,    -1,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    32,    33,    34,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    47,    -1,
      -1,    -1,    -1,    -1,    53,    -1,    -1,    -1,    -1,    -1,
      -1,    60,    61,    -1,    63,    64,    -1,    -1,    -1,    68,
       3,     4,     5,     6,     7,    -1,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,
      33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    47,    -1,    -1,    -1,    -1,    -1,
      53,    -1,    -1,    -1,    -1,    -1,    -1,    60,    61,    -1,
      63,    64,    -1,    -1,    -1,    68,     3,     4,     5,     6,
       7,    -1,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    32,    33,    34,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      47,    -1,    -1,    -1,    -1,    -1,    53,    -1,    -1,    -1,
      -1,    -1,    -1,    60,    61,    -1,    63,    64,    -1,    -1,
      -1,    68,     3,     4,     5,     6,     7,    -1,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    -1,    -1,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    -1,
      -1,    32,    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    47,    -1,    32,    33,
      34,    -1,    53,    -1,    -1,    -1,    -1,    -1,    -1,    60,
      61,    -1,    63,    47,    -1,    -1,    -1,    68,    -1,    53,
      -1,     3,     4,     5,     6,     7,    60,    61,    -1,    63,
      12,    -1,    -1,    -1,    68,    -1,    -1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    -1,    -1,
      32,    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    47,    -1,    32,    33,    34,
      -1,    53,    -1,    -1,    -1,    -1,    -1,    -1,    60,    61,
      -1,    63,    47,    -1,    -1,    -1,    68,    -1,    53,    -1,
      -1,     3,     4,     5,     6,     7,    61,    -1,    63,    64,
      12,    -1,    -1,    68,    -1,    -1,    -1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    -1,    -1,
      32,    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    47,    -1,    32,    33,    34,
      -1,    53,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,
      62,    63,    47,    -1,    -1,    -1,    68,    -1,    53,    -1,
       3,     4,     5,     6,     7,    -1,    61,    62,    63,    12,
      -1,    -1,    -1,    68,    -1,    -1,    -1,     3,     4,     5,
       6,     7,    -1,    -1,    -1,    -1,    12,    -1,    -1,    32,
      33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    47,    -1,    32,    33,    34,    -1,
      53,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,    62,
      63,    47,    -1,    -1,    -1,    68,    -1,    53,    -1,     3,
       4,     5,     6,     7,    -1,    61,    -1,    63,    12,    -1,
      -1,    -1,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,    33,
      34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    47,    -1,    20,    21,    -1,    -1,    53,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,    -1,    63,
      -1,    36,    37,    -1,    68,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    20,    21,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    69,    -1,    -1,    -1,    -1,    -1,
      36,    37,    -1,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    -1,    69,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    36,    37,    -1,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    20,
      21,    -1,    62,    61,    -1,    -1,    -1,    -1,    66,    67,
      68,    -1,    -1,    -1,    -1,    36,    37,    -1,    -1,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    20,    21,
      -1,    62,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    36,    37,    -1,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    20,    21,    -1,
      62,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    36,    37,    -1,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    20,    21,    -1,    62,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    36,    37,    -1,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    20,    21,    -1,    62,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    36,    37,    -1,    -1,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    20,    21,    -1,    62,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      36,    37,    -1,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    -1,    60,    20,    21,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    36,    37,    -1,    -1,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    -1,    60,    20,    21,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    36,    37,    -1,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    -1,    60,    20,    21,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    36,    37,    -1,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    -1,    60,    20,    21,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    36,    37,    -1,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    -1,    60,    20,
      21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    36,    37,    -1,    -1,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    -1,    60,
      20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    36,    37,    -1,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    -1,
      60,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    36,    37,    38,
      -1,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    20,
      21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    20,    21,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    36,    37,    -1,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    36,    37,    -1,
      -1,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    71,    72,     0,     3,     4,     5,     6,     7,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    32,    33,
      34,    47,    53,    60,    61,    63,    68,    73,    74,    78,
      79,    61,    61,    61,    61,    63,    78,    61,     7,    76,
       7,    76,    60,    12,    60,    63,    79,    78,    78,    79,
      78,    79,    79,     7,    64,    74,    77,    79,    69,    75,
      79,    73,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    61,    66,    67,    68,    20,    21,
      36,    37,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    60,    79,    60,    79,    79,     7,    76,    74,    61,
      63,    14,    78,    66,    60,    65,    66,    60,    79,    60,
      61,    62,    35,    64,    64,    65,    39,    65,    69,    38,
      79,    79,    79,    79,    79,    79,    79,    79,    79,    79,
      62,    75,    79,    79,     4,     7,    79,    79,    79,    79,
      79,    79,    79,    79,    79,    79,    79,    79,    79,    79,
      79,    79,    79,    79,    79,    79,    79,    79,    79,    78,
      62,    60,    60,    62,    62,    64,    62,    76,    74,    78,
      65,    79,     7,    79,    62,    75,    79,     7,    79,    79,
      79,    79,    62,    69,    61,    73,    62,    79,    73,    63,
      63,    62,    64,    65,    79,    60,    60,    62,    35,    39,
      69,    62,    75,    73,    60,    19,    74,    74,    63,    79,
      62,    79,    79,    62,    79,    73,    64,    64,    74,    62,
      73,    62,    64,    73,    73
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1455 of yacc.c  */
#line 113 "mpsl.y"
    { ; }
    break;

  case 3:

/* Line 1455 of yacc.c  */
#line 117 "mpsl.y"
    {
					mpsl_bytecode = (yyvsp[(2) - (2)].ins);
				}
    break;

  case 5:

/* Line 1455 of yacc.c  */
#line 124 "mpsl.y"
    {
					/* null instruction */
					(yyval.ins) = INS0(L"MULTI");
				}
    break;

  case 6:

/* Line 1455 of yacc.c  */
#line 128 "mpsl.y"
    {
					/* expression, as is */
					(yyval.ins) = (yyvsp[(1) - (2)].ins);
				}
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 134 "mpsl.y"
    {
					/* while loop */
					(yyval.ins) = INS2(L"WHILE", (yyvsp[(3) - (5)].ins), (yyvsp[(5) - (5)].ins));
				}
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 139 "mpsl.y"
    {
                    /* for loop */
                    (yyval.ins) = INS4(L"WHILE", (yyvsp[(5) - (9)].ins), (yyvsp[(9) - (9)].ins), (yyvsp[(3) - (9)].ins), (yyvsp[(7) - (9)].ins));
                }
    break;

  case 9:

/* Line 1455 of yacc.c  */
#line 144 "mpsl.y"
    {
                    /* infinite loop */
                    (yyval.ins) = INS2(L"WHILE", INS1(L"LITERAL", MPDM_I(1)), (yyvsp[(6) - (6)].ins));
                }
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 149 "mpsl.y"
    {
					/* if - then construction */
					(yyval.ins) = INS2(L"IF", (yyvsp[(3) - (5)].ins), (yyvsp[(5) - (5)].ins));
				}
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 154 "mpsl.y"
    {
					/* if - then - else construction */
					(yyval.ins) = INS3(L"IF", (yyvsp[(3) - (7)].ins), (yyvsp[(5) - (7)].ins), (yyvsp[(7) - (7)].ins));
				}
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 160 "mpsl.y"
    {
					/* subroutine definition,
					   without arguments */
					(yyval.ins) = INS2(L"ASSIGN", (yyvsp[(2) - (5)].ins),
						INS1(L"LITERAL",
							mpsl_x((yyvsp[(4) - (5)].ins), NULL, 1)));
				}
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 169 "mpsl.y"
    {
					/* subroutine definition,
					   without arguments (second
					   syntax, including parens) */
					(yyval.ins) = INS2(L"ASSIGN", (yyvsp[(2) - (7)].ins),
						INS1(L"LITERAL",
							mpsl_x((yyvsp[(6) - (7)].ins), NULL, 1)));
				}
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 179 "mpsl.y"
    {
					/* subroutine definition,
					   with arguments */
					(yyval.ins) = INS2(L"ASSIGN", (yyvsp[(2) - (8)].ins),
						INS1(L"LITERAL",
							mpsl_x((yyvsp[(7) - (8)].ins), (yyvsp[(4) - (8)].ins), 1)));
				}
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 188 "mpsl.y"
    {
					/* foreach construction */
					/* a block frame is created, the iterator
					   created as local, and the foreach executed */
					(yyval.ins) = INS1(L"BLKFRAME",
						INS2(L"MULTI",
							INS1(L"LOCAL", (yyvsp[(3) - (7)].ins)),
							INS3(L"FOREACH", (yyvsp[(3) - (7)].ins), (yyvsp[(5) - (7)].ins), (yyvsp[(7) - (7)].ins))
						)
					);
				}
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 200 "mpsl.y"
    {
					compiler_warning("useless use of local in foreach loop");

					(yyval.ins) = INS1(L"BLKFRAME",
						INS2(L"MULTI",
							INS1(L"LOCAL", (yyvsp[(4) - (8)].ins)),
							INS3(L"FOREACH", (yyvsp[(4) - (8)].ins), (yyvsp[(6) - (8)].ins), (yyvsp[(8) - (8)].ins))
						)
					);
				}
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 211 "mpsl.y"
    {
					/* block of instructions,
					   with local symbol table */
					(yyval.ins) = INS1(L"BLKFRAME", (yyvsp[(2) - (3)].ins));
				}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 217 "mpsl.y"
    {
					/* local symbol creation */
					(yyval.ins) = INS1(L"LOCAL", (yyvsp[(2) - (3)].ins));
				}
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 222 "mpsl.y"
    {
					/* contraction; local symbol
					   creation and assignation */
					(yyval.ins) = INS2(L"MULTI",
						INS1(L"LOCAL",
							INS1(L"LITERAL", (yyvsp[(2) - (5)].v))),
						INS2(L"ASSIGN",
							INS1(L"LITERAL", (yyvsp[(2) - (5)].v)),(yyvsp[(4) - (5)].ins))
						);
				}
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 232 "mpsl.y"
    {
					/* global symbol creation */
					(yyval.ins) = INS1(L"GLOBAL", (yyvsp[(2) - (3)].ins));
				}
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 237 "mpsl.y"
    {
					/* contraction; global symbol
					   creation and assignation */
					(yyval.ins) = INS2(L"MULTI",
						INS1(L"GLOBAL",
							INS1(L"LITERAL", (yyvsp[(2) - (5)].v))),
						INS2(L"ASSIGN",
							INS1(L"LITERAL", (yyvsp[(2) - (5)].v)),(yyvsp[(4) - (5)].ins))
						);
				}
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 247 "mpsl.y"
    {
					/* break (exit from loop) */
					(yyval.ins) = INS0(L"BREAK");
				}
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 251 "mpsl.y"
    {
					/* return from subroutine */
					(yyval.ins) = INS1(L"RETURN", (yyvsp[(2) - (3)].ins));
				}
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 255 "mpsl.y"
    {
					/* return from subroutine (void) */
					(yyval.ins) = INS0(L"RETURN");
				}
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 262 "mpsl.y"
    { (yyval.ins) = (yyvsp[(1) - (1)].ins); }
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 263 "mpsl.y"
    {
					/* sequence of instructions */
					(yyval.ins) = INS2(L"MULTI", (yyvsp[(1) - (2)].ins), (yyvsp[(2) - (2)].ins));
				}
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 270 "mpsl.y"
    {
					(yyval.ins) = INS1(L"LIST", (yyvsp[(1) - (1)].ins));
				}
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 273 "mpsl.y"
    {
					/* build list from list of
					   instructions */
					(yyval.ins) = INS2(L"LIST", (yyvsp[(3) - (3)].ins), (yyvsp[(1) - (3)].ins));
				}
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 281 "mpsl.y"
    {
					(yyval.ins) = INS1(L"LIST",
						INS1(L"LITERAL", (yyvsp[(1) - (1)].v)));
				}
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 285 "mpsl.y"
    {
					/* comma-separated list of symbols */
					(yyval.ins) = INS2(L"LIST",
						INS1(L"LITERAL", (yyvsp[(3) - (3)].v)), (yyvsp[(1) - (3)].ins));
				}
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 293 "mpsl.y"
    {
                (yyval.ins) = INS2(L"HASH", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins));
                }
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 296 "mpsl.y"
    {
                (yyval.ins) = INS2(L"HASH", INS1(L"LITERAL", (yyvsp[(1) - (3)].v)), (yyvsp[(3) - (3)].ins));
                }
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 300 "mpsl.y"
    {
                    /* build hash from list of
                       instructions */
                    (yyval.ins) = INS3(L"HASH", (yyvsp[(3) - (5)].ins), (yyvsp[(5) - (5)].ins), (yyvsp[(1) - (5)].ins));
                }
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 306 "mpsl.y"
    {
                    /* build hash from list of
                       instructions */
                    (yyval.ins) = INS3(L"HASH", INS1(L"LITERAL", (yyvsp[(3) - (5)].v)), (yyvsp[(5) - (5)].ins), (yyvsp[(1) - (5)].ins));
                }
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 314 "mpsl.y"
    {
					(yyval.ins) = INS1(L"LIST",
						INS1(L"LITERAL", (yyvsp[(1) - (1)].v)));
				}
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 318 "mpsl.y"
    {
					/* a.5 compound symbol */
					(yyval.ins) = INS2(L"LIST",
						INS1(L"LITERAL", (yyvsp[(3) - (3)].v)), (yyvsp[(1) - (3)].ins));
				}
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 323 "mpsl.y"
    {
					/* a.b compound symbol */
					(yyval.ins) = INS2(L"LIST",
						INS1(L"LITERAL", (yyvsp[(3) - (3)].v)), (yyvsp[(1) - (3)].ins));
				}
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 328 "mpsl.y"
    {
					/* a["b"] or a[5] compound symbol */
					(yyval.ins) = INS2(L"LIST", (yyvsp[(3) - (4)].ins), (yyvsp[(1) - (4)].ins));
				}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 335 "mpsl.y"
    {
					/* literal integer */
					(yyval.ins) = INS1(L"LITERAL", (yyvsp[(1) - (1)].v));
				}
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 339 "mpsl.y"
    {
					/* literal string */
					(yyval.ins) = INS1(L"LITERAL", (yyvsp[(1) - (1)].v));
				}
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 343 "mpsl.y"
    {
					/* literal real number */
					(yyval.ins) = INS1(L"LITERAL", (yyvsp[(1) - (1)].v));
				}
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 347 "mpsl.y"
    {
					/* compound symbol */
					(yyval.ins) = INS1(L"SYMVAL", (yyvsp[(1) - (1)].ins));
				}
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 351 "mpsl.y"
    {
					/* NULL value */
					(yyval.ins) = INS1(L"LITERAL", NULL);
				}
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 356 "mpsl.y"
    {
					/* unary minus */
					(yyval.ins) = INS1(L"UMINUS", (yyvsp[(2) - (2)].ins));
				}
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 362 "mpsl.y"
    { (yyval.ins) = INS2(L"ADD", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)); }
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 363 "mpsl.y"
    { (yyval.ins) = INS2(L"SUB", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)); }
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 364 "mpsl.y"
    { (yyval.ins) = INS2(L"MUL", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)); }
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 365 "mpsl.y"
    { (yyval.ins) = INS2(L"DIV", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)); }
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 366 "mpsl.y"
    { (yyval.ins) = INS2(L"MOD", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)); }
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 367 "mpsl.y"
    { (yyval.ins) = INS2(L"POW", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)); }
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 370 "mpsl.y"
    { (yyval.ins) = INS2(L"BITAND", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)); }
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 371 "mpsl.y"
    { (yyval.ins) = INS2(L"BITOR", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)); }
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 372 "mpsl.y"
    { (yyval.ins) = INS2(L"BITXOR", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)); }
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 373 "mpsl.y"
    { (yyval.ins) = INS2(L"SHL", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)); }
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 374 "mpsl.y"
    { (yyval.ins) = INS2(L"SHR", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)); }
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 377 "mpsl.y"
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[(2) - (2)].ins),
					INS2(L"ADD",
						INS1(L"SYMVAL", (yyvsp[(2) - (2)].ins)),
						INS1(L"LITERAL", MPDM_I(1))
						)
					);
				}
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 384 "mpsl.y"
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[(2) - (2)].ins),
					INS2(L"SUB",
						INS1(L"SYMVAL", (yyvsp[(2) - (2)].ins)),
						INS1(L"LITERAL", MPDM_I(1))
						)
					);
				}
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 393 "mpsl.y"
    { (yyval.ins) = INS2(L"IMULTI",
					INS1(L"SYMVAL", (yyvsp[(1) - (2)].ins)),
					INS2(L"ASSIGN", (yyvsp[(1) - (2)].ins),
						INS2(L"ADD",
							INS1(L"SYMVAL", (yyvsp[(1) - (2)].ins)),
							INS1(L"LITERAL", MPDM_I(1))
							)
						)
					);
				}
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 403 "mpsl.y"
    { (yyval.ins) = INS2(L"IMULTI",
					INS1(L"SYMVAL", (yyvsp[(1) - (2)].ins)),
					INS2(L"ASSIGN", (yyvsp[(1) - (2)].ins),
						INS2(L"SUB",
							INS1(L"SYMVAL", (yyvsp[(1) - (2)].ins)),
							INS1(L"LITERAL", MPDM_I(1))
							)
						)
					);
				}
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 415 "mpsl.y"
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[(1) - (3)].ins),
					INS2(L"ADD",
						INS1(L"SYMVAL", (yyvsp[(1) - (3)].ins)),
						(yyvsp[(3) - (3)].ins))
					);
				}
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 421 "mpsl.y"
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[(1) - (3)].ins),
					INS2(L"SUB",
						INS1(L"SYMVAL", (yyvsp[(1) - (3)].ins)),
						(yyvsp[(3) - (3)].ins))
					);
				}
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 427 "mpsl.y"
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[(1) - (3)].ins),
					INS2(L"MUL",
						INS1(L"SYMVAL", (yyvsp[(1) - (3)].ins)),
						(yyvsp[(3) - (3)].ins))
					);
				}
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 433 "mpsl.y"
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[(1) - (3)].ins),
					INS2(L"DIV",
						INS1(L"SYMVAL", (yyvsp[(1) - (3)].ins)),
						(yyvsp[(3) - (3)].ins))
					);
				}
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 439 "mpsl.y"
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[(1) - (3)].ins),
					INS2(L"MOD",
						INS1(L"SYMVAL", (yyvsp[(1) - (3)].ins)),
						(yyvsp[(3) - (3)].ins))
					);
				}
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 445 "mpsl.y"
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[(1) - (3)].ins),
					INS2(L"BITAND",
						INS1(L"SYMVAL", (yyvsp[(1) - (3)].ins)),
						(yyvsp[(3) - (3)].ins))
					);
				}
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 451 "mpsl.y"
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[(1) - (3)].ins),
					INS2(L"BITOR",
						INS1(L"SYMVAL", (yyvsp[(1) - (3)].ins)),
						(yyvsp[(3) - (3)].ins))
					);
				}
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 457 "mpsl.y"
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[(1) - (3)].ins),
					INS2(L"BITXOR",
						INS1(L"SYMVAL", (yyvsp[(1) - (3)].ins)),
						(yyvsp[(3) - (3)].ins))
					);
				}
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 463 "mpsl.y"
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[(1) - (3)].ins),
					INS2(L"SHL",
						INS1(L"SYMVAL", (yyvsp[(1) - (3)].ins)),
						(yyvsp[(3) - (3)].ins))
					);
				}
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 469 "mpsl.y"
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[(1) - (3)].ins),
					INS2(L"SHR",
						INS1(L"SYMVAL", (yyvsp[(1) - (3)].ins)),
						(yyvsp[(3) - (3)].ins))
					);
				}
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 476 "mpsl.y"
    {
					/* boolean not */
					(yyval.ins) = INS1(L"NOT", (yyvsp[(2) - (2)].ins));
				}
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 480 "mpsl.y"
    {
					/* bool less than */
					(yyval.ins) = INS2(L"NUMLT", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins));
				}
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 484 "mpsl.y"
    {
					/* bool greater than */
					(yyval.ins) = INS2(L"NUMGT", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins));
				}
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 488 "mpsl.y"
    {
					/* bool less or equal than */
					(yyval.ins) = INS2(L"NUMLE", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins));
				}
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 492 "mpsl.y"
    {
					/* bool greater or equal than */
					(yyval.ins) = INS2(L"NUMGE", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins));
				}
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 496 "mpsl.y"
    {
					/* bool numeric equal */
					(yyval.ins) = INS2(L"NUMEQ", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins));
				}
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 500 "mpsl.y"
    {
					/* bool numeric non-equal */
					(yyval.ins) = INS1(L"NOT",
						INS2(L"NUMEQ", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)));
				}
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 506 "mpsl.y"
    {
					/* string concatenation */
					(yyval.ins) = INS2(L"STRCAT", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins));
				}
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 510 "mpsl.y"
    {
					/* bool string equal */
					(yyval.ins) = INS2(L"STREQ", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins));
				}
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 514 "mpsl.y"
    {
					/* bool string non-equal */
					(yyval.ins) = INS1(L"NOT",
						INS2(L"STREQ", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)));
				}
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 520 "mpsl.y"
    {
					/* boolean and */
					(yyval.ins) = INS2(L"AND", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins));
				}
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 524 "mpsl.y"
    {
					/* boolean or */
					(yyval.ins) = INS2(L"OR", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins));
				}
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 529 "mpsl.y"
    {
					/* anonymous subroutine (without args) */
					(yyval.ins) = INS1(L"LITERAL", mpsl_x((yyvsp[(3) - (4)].ins), NULL, 0));
				}
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 535 "mpsl.y"
    {
					/* anonymous subroutine (with args) */
					(yyval.ins) = INS1(L"LITERAL", mpsl_x((yyvsp[(6) - (7)].ins), (yyvsp[(3) - (7)].ins), 0));
				}
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 540 "mpsl.y"
    {
					/* parenthesized expression */
					(yyval.ins) = (yyvsp[(2) - (3)].ins);
				}
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 545 "mpsl.y"
    {
					/* empty list */
					(yyval.ins) = INS1(L"LITERAL", MPDM_A(0));
				}
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 549 "mpsl.y"
    {
					/* non-empty list */
					(yyval.ins) = (yyvsp[(2) - (3)].ins);
				}
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 554 "mpsl.y"
    {
					/* build range from expressions */
					(yyval.ins) = INS2(L"RANGE", (yyvsp[(2) - (5)].ins), (yyvsp[(4) - (5)].ins));
				}
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 559 "mpsl.y"
    {
					/* empty hash */
					(yyval.ins) = INS1(L"LITERAL", MPDM_H(0));
				}
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 563 "mpsl.y"
    {
					/* non-empty hash */
					(yyval.ins) = (yyvsp[(2) - (3)].ins);
				}
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 568 "mpsl.y"
    {
					/* function call (without args) */
					(yyval.ins) = INS1(L"EXECSYM", (yyvsp[(1) - (3)].ins));
				}
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 572 "mpsl.y"
    {
					/* function call (with args) */
					(yyval.ins) = INS2(L"EXECSYM", (yyvsp[(1) - (4)].ins), (yyvsp[(3) - (4)].ins));
				}
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 576 "mpsl.y"
    {
					/* function call with only an inverse argument */
					(yyval.ins) = INS2(L"METHOD", (yyvsp[(3) - (5)].ins), INS1(L"ILIST", (yyvsp[(1) - (5)].ins)));
				}
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 580 "mpsl.y"
    {
					/* function call with inverse argument and other ones */
					(yyval.ins) = INS2(L"METHOD", (yyvsp[(3) - (6)].ins), INS2(L"ILIST", (yyvsp[(1) - (6)].ins), (yyvsp[(5) - (6)].ins)));
				}
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 584 "mpsl.y"
    {
					/* function call as a new thread (without args) */
					(yyval.ins) = INS1(L"THREADSYM", (yyvsp[(2) - (4)].ins));
				}
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 588 "mpsl.y"
    {
					/* function call as a new thread (with args) */
					(yyval.ins) = INS2(L"THREADSYM", (yyvsp[(2) - (5)].ins), (yyvsp[(4) - (5)].ins));
				}
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 592 "mpsl.y"
    {
					/* simple assignation */
					(yyval.ins) = INS2(L"ASSIGN", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins));
				}
    break;



/* Line 1455 of yacc.c  */
#line 2994 "y.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 599 "mpsl.y"


void yyerror(char *s)
{
    char tmp[1024];

    snprintf(tmp, sizeof(tmp), "%s in %s, line %d",
             s, mpsl_filename, mpsl_line + 1);

    mpsl_error(MPDM_MBS(tmp));
}


static FILE *inc_fopen(const char *filename, mpdm_t inc)
/* loads filename, searching in INC if not directly accesible */
{
    FILE *f = NULL;
    char tmp[1024];
    int n;

    /* loop through INC, prepending each path
       to the filename */
    for (n = 0; n < mpdm_size(inc); n++) {
        mpdm_t v = mpdm_aget(inc, n);

        v = mpdm_ref(MPDM_2MBS(v->data));
        snprintf(tmp, sizeof(tmp), "%s/%s", (char *) v->data, filename);
        mpdm_unref(v);

        if ((f = fopen(tmp, "r")) != NULL)
            break;
    }

    return f;
}


static mpdm_t do_parse(const char *filename, wchar_t * code, FILE * file)
/* calls yyparse() after doing some initialisations, and returns
   the compiled code as an executable value */
{
    mpdm_t v;
    mpdm_t x = NULL;

    /* first line */
    mpsl_line = 0;

    /* reset last bytecode */
    mpsl_bytecode = NULL;

    /* set globals */
    mpsl_next_char = code;
    mpsl_file = file;

    if (mpsl_filename != NULL)
        free(mpsl_filename);

    mpsl_filename = strdup(filename);

    /* cache some values */
    v = mpdm_hget_s(mpdm_root(), L"MPSL");
    mpsl_opcodes = mpdm_hget_s(v, L"OPCODE");
    mpsl_lc = mpdm_hget_s(v, L"LC");

    /* compile! */
    if (yyparse() == 0 && mpsl_bytecode != NULL)
        x = mpsl_x(mpsl_bytecode, NULL, 1);

    /* clean back cached values */
    mpsl_opcodes = NULL;
    mpsl_lc = NULL;

    return x;
}


/**
 * mpsl_compile - Compiles a string of MPSL code.
 * @code: A value containing a string of MPSL code
 *
 * Compiles a string of MPSL code and returns an mpdm value executable
 * by mpdm_exec(). If there is a syntax (or other type) error, NULL
 * is returned instead.
 */
mpdm_t mpsl_compile(mpdm_t code)
{
    mpdm_t x = NULL;

    mpdm_ref(code);
    x = do_parse("<INLINE>", (wchar_t *) code->data, NULL);
    mpdm_unref(code);

    return x;
}


/**
 * mpsl_compile_file - Compiles a file of MPSL code.
 * @file: File stream or file name.
 * @inc: search path for source files.
 *
 * Compiles a source file of MPSL code and returns an mpdm value
 * executable by mpdm_exec(). If @file is an MPSL file descriptor,
 * it's read as is and compiled; otherwise, it's assumed to be a
 * file name, that will be searched for in any of the paths defined
 * in the @inc array. If the file cannot be found
 * or there is any other error, NULL is returned instead.
 */
mpdm_t mpsl_compile_file(mpdm_t file, mpdm_t inc)
{
    mpdm_t w;
    mpdm_t x = NULL;
    FILE *f = NULL;
    const char *filename = NULL;

    mpdm_ref(file);
    mpdm_ref(inc);

    if ((f = mpdm_get_filehandle(file)) != NULL) {
        filename = "<FILE>";
        w = file;
    }
    else {
        mpdm_t v;

        /* it's a filename; open it */
        v = mpdm_ref(MPDM_2MBS(file->data));

        filename = v->data;

        if ((f = inc_fopen(filename, inc)) == NULL) {
            char tmp[128];

            snprintf(tmp, sizeof(tmp) - 1,
                     "File '%s' not found in INC", filename);
            mpsl_error(MPDM_MBS(tmp));
        }

        mpdm_unref(v);

        w = MPDM_F(f);
    }

    if (w != NULL) {
        x = do_parse(filename, NULL, f);
        mpdm_close(w);
    }

    mpdm_unref(inc);
    mpdm_unref(file);

    return x;
}


/**
 * mpsl_eval - Evaluates MSPL code.
 * @code: A value containing a string of MPSL code, or executable code
 * @args: optional arguments for @code
 * @ctxt: context for @code
 *
 * Evaluates a piece of code. The @code can be a string containing MPSL source
 * code (that will be compiled) or a direct executable value. If the compilation
 * or the execution gives an error, the ERROR variable will be set to a printable
 * value and NULL returned. Otherwise, the exit value from the code is returned
 * and ERROR set to NULL. The abort flag is reset on exit.
 */
mpdm_t mpsl_eval(mpdm_t code, mpdm_t args, mpdm_t ctxt)
{
    mpdm_t cs, r;

    /* reset error */
    mpsl_error(NULL);
    mpsl_abort = 0;

    mpdm_ref(code);

    /* if code is not executable, try to compile */
    if (!MPDM_IS_EXEC(code)) {
        mpdm_t c;

        /* get the eval cache */
        if ((c = mpdm_hget_s(mpdm_root(), L"__EVAL__")) == NULL)
            c = mpdm_hset_s(mpdm_root(), L"__EVAL__", MPDM_H(0));

        /* this code still not compiled? do it */
        if ((cs = mpdm_hget(c, code)) == NULL)
            cs = mpdm_hset(c, code, mpsl_compile(code));
    }
    else
        cs = code;

    /* execute, if possible */
    if (MPDM_IS_EXEC(cs))
        r = mpdm_exec(cs, args, ctxt);
    else
        r = NULL;

    /* reset the abort flag */
    mpsl_abort = 0;

    mpdm_unref(code);

    return r;
}

